#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire400seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire400seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven4004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven4004xi = {
                1:'-101x-131y363z',
                2:'-105x-123y365z',
                3:'-105x-332y196z',
                4:'-109x-115y367z',
                5:'-10x-18y399z',
                6:'-10x-44y397z',
                7:'-111x-20y383z',
                8:'-112x-106y368z',
                9:'-114x-27y382z',
                10:'-115x-98y370z',
                11:'-116x-34y381z',
                12:'-117x-362y120z',
                13:'-117x-89y371z',
                14:'-118x-41y379z',
                15:'-118x-81y373z',
                16:'-119x-49y378z',
                17:'-119x-57y377z',
                18:'-119x-73y374z',
                19:'-11x-22y399z',
                20:'-11x-39y397z',
                21:'-120x-65y375z',
                22:'-122x-324y199z',
                23:'-12x-26y398z',
                24:'-12x-30y398z',
                25:'-12x-35y398z',
                26:'-136x-354y124z',
                27:'-138x-315y203z',
                28:'-143x-149y342z',
                29:'-148x-139y344z',
                30:'-152x-128y346z',
                31:'-153x-306y206z',
                32:'-154x-346y128z',
                33:'-156x-118y348z',
                34:'-159x-108y350z',
                35:'-162x-98y352z',
                36:'-163x-87y354z',
                37:'-165x-67y357z',
                38:'-165x-77y355z',
                39:'-168x-295y209z',
                40:'-16x-204y343z',
                41:'-16x-357y178z',
                42:'-171x-198y425z',
                43:'-171x-336y132z',
                44:'-182x-284y213z',
                45:'-188x-325y136z',
                46:'-196x-273y216z',
                47:'-1x0y399z',
                48:'-204x-314y139z',
                49:'-204x-343y0z',
                50:'-208x-260y219z',
                51:'-20x-386y101z',
                52:'-219x-302y143z',
                53:'-220x-247y223z',
                54:'-222x-332y4z',
                55:'-231x-234y226z',
                56:'-234x-289y147z',
                57:'-239x-320y8z',
                58:'-241x-220y229z',
                59:'-247x-275y151z',
                60:'-251x-206y233z',
                61:'-255x-307y12z',
                62:'-259x-191y236z',
                63:'-260x-260y154z',
                64:'-267x-176y239z',
                65:'-26x-199y345z',
                66:'-271x-293y16z',
                67:'-272x-245y158z',
                68:'-274x-160y242z',
                69:'-280x-144y245z',
                70:'-284x-230y162z',
                71:'-285x-128y249z',
                72:'-286x-278y20z',
                73:'-289x-112y252z',
                74:'-292x-96y255z',
                75:'-294x-213y165z',
                76:'-294x-80y258z',
                77:'-295x-64y261z',
                78:'-300x-263y24z',
                79:'-303x-197y169z',
                80:'-312x-180y172z',
                81:'-313x-247y28z',
                82:'-319x-162y176z',
                83:'-325x-230y32z',
                84:'-326x-145y180z',
                85:'-331x-127y183z',
                86:'-336x-109y187z',
                87:'-336x-212y36z',
                88:'-339x-90y190z',
                89:'-342x-72y194z',
                90:'-343x-36y201z',
                91:'-343x-54y197z',
                92:'-347x-194y40z',
                93:'-356x-175y44z',
                94:'-35x-354y181z',
                95:'-364x-156y48z',
                96:'-36x-194y347z',
                97:'-371x-137y52z',
                98:'-378x-117y56z',
                99:'-383x-97y60z',
                100:'-3x-3y399z',
                101:'-3x-57y395z',
                102:'-40x-383y105z',
                103:'-45x-189y349z',
                104:'-53x-350y185z',
                105:'-54x-183y351z',
                106:'-5x-208y341z',
                107:'-60x-379y109z',
                108:'-62x-176y353z',
                109:'-6x-52y396z',
                110:'-6x-7y399z',
                111:'-70x-170y355z',
                112:'-71x-345y189z',
                113:'-77x-162y356z',
                114:'-79x-375y113z',
                115:'-84x-155y358z',
                116:'-88x-339y192z',
                117:'-8x-10y399z',
                118:'-8x-48y396z',
                119:'-90x-147y360z',
                120:'-96x-139y362z',
                121:'-98x-369y117z',
                122:'-9x-14y399z',
                123:'0x-387y97z',
                124:'0x-61y395z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire400seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire400seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE400SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE400SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE400SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE400SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE400SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven4004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE400SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE400SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE400SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven4004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven4004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE400SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE400SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE400SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire400seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       